## ?zip=crc

=== Makefile ===
#!/usr/bin/env make

# SPDX-FileCopyrightText: 2023 Patrick Spek <p.spek@tyil.nl>
#
# SPDX-License-Identifier: AGPL-3.0-or-later

DESTDIR=/usr
ETCDIR=/etc

# Variables for building (binary) packages
PREFIX=
PKG_VERSION=2.1.0
PKG_WORKDIR:=$(or $(PKG_WORKDIR),$(shell mktemp -d))
PKG_ROOT:=$(PKG_WORKDIR)/bashtard-$(PKG_VERSION)
SOURCE_DATE_EPOCH:=$(shell git show -s --format=%ct)

rwildcard=$(foreach d,$(wildcard $(1:=/*)),$(call rwildcard,$d,$2) $(filter $(subst *,%,$2),$d))

all:
	: # No build step required, use `make install` to install this program

install: bin lib share

uninstall:
	rm -fv -- "$(PREFIX)$(DESTDIR)/bin/bashtard"
	rm -rfv -- "$(PREFIX)$(DESTDIR)/lib/bashtard"
	rm -rfv -- "$(PREFIX)$(DESTDIR)/share/bashtard"

bin:
	mkdir -pv -- "$(PREFIX)$(DESTDIR)/bin"
	sed \
		-e 's@BASHTARD_LIBDIR=.*@BASHTARD_LIBDIR="$(DESTDIR)/lib/bashtard"@' \
		-e 's@BASHTARD_SHAREDIR=.*@BASHTARD_SHAREDIR="$(DESTDIR)/share/bashtard"@' \
		-e 's@BASHTARD_ETCDIR=.*@BASHTARD_ETCDIR="$(ETCDIR)/bashtard"@' \
		bin/bashtard > "$(PREFIX)$(DESTDIR)/bin/bashtard"
	chmod +x "$(PREFIX)$(DESTDIR)/bin/bashtard"

lib:
	mkdir -pv -- "$(PREFIX)$(DESTDIR)/lib/bashtard"
	cp -rv -- lib/* "$(PREFIX)$(DESTDIR)/lib/bashtard"

man:
	mkdir -pv -- "$(PREFIX)$(DESTDIR)/share/man/man1"
	mkdir -pv -- "$(PREFIX)$(DESTDIR)/share/man/man3"
	mkdir -pv -- "$(PREFIX)$(DESTDIR)/share/man/man5"
	mkdir -pv -- "$(PREFIX)$(DESTDIR)/share/man/man7"
	scdoc < share/doc/bashtard.1.scd | gzip -cn9 > "$(PREFIX)$(DESTDIR)/share/man/man1/bashtard.1.gz"
	scdoc < share/doc/bashtard.3.scd | gzip -cn9 > "$(PREFIX)$(DESTDIR)/share/man/man3/bashtard.3.gz"
	scdoc < share/doc/bashtard.5.scd | gzip -cn9 > "$(PREFIX)$(DESTDIR)/share/man/man5/bashtard.5.gz"
	scdoc < share/doc/bashtard.7.scd | gzip -cn9 > "$(PREFIX)$(DESTDIR)/share/man/man7/bashtard.7.gz"
	scdoc < share/doc/playbooks.d.7.scd | gzip -cn9 > "$(PREFIX)$(DESTDIR)/share/man/man7/playbooks.d.7.gz"

pkg-debian:
	# Create the directories to work with
	mkdir -pv -- "$(PKG_ROOT)/usr"

	# Install into the workdir
	$(MAKE) PREFIX="$(PKG_ROOT)" install
	$(MAKE) PREFIX="$(PKG_ROOT)" man

	# Copy Debian's control file
	mkdir -pv -- "$(PKG_ROOT)/DEBIAN"
	printf "Version: %s\n" "$(PKG_VERSION)" > "$(PKG_ROOT)/DEBIAN/control"
	grep -v '^\#' ./etc/debian/control >> "$(PKG_ROOT)/DEBIAN/control"

	# Include the changelog
	mkdir -pv -- "$(PKG_ROOT)/usr/share/doc/bashtard"
	gzip -9n < CHANGELOG.md > "$(PKG_ROOT)/usr/share/doc/bashtard/changelog.gz"

	# Include license
	cp -v -- LICENSES/AGPL-3.0-or-later.txt "$(PKG_ROOT)/usr/share/doc/bashtard/copyright"

	# Debian wants all .bash files to be +x
	find "$(PKG_ROOT)" -type f -iname "*.bash" | xargs chmod +x

	# Generate the .deb file
	mkdir -pv -- "dist"
	dpkg-deb -b "$(PKG_ROOT)" "dist/bashtard-$(PKG_VERSION).deb"

pkg-targz:
	mkdir -pv -- "dist"
	tar \
		--exclude dist \
		--group=0 \
		--mtime="@$(SOURCE_DATE_EPOCH)" \
		--numeric-owner \
		--owner=0 \
		--pax-option="exthdr.name=%d/PaxHeaders/%f,delete=atime,delete=ctime" \
		--sort=name \
		--transform "s@^./@bashtard-$(PKG_VERSION)/@" \
		--exclude-vcs \
		--exclude-vcs-ignores \
		-cvzf "dist/bashtard-$(PKG_VERSION).tar.gz" .

qa:
	# Check licenses
	reuse lint

	# Check code
	shellcheck -s sh bin/bashtard
	shellcheck -s bash $(call rwildcard,.,*.bash)

share:
	mkdir -pv -- "$(PREFIX)$(DESTDIR)/share/bashtard"
	cp -rv -- \
		share/defaults \
		share/os.d \
		"$(PREFIX)$(DESTDIR)/share/bashtard"

.PHONY: all install uninstall pkg-debian qa bin lib man share
