=== etc/debian/control ===
#SPDX-FileCopyrightText: 2023 Patrick Spek <p.spek@tyil.nl>
#
#SPDX-License-Identifier: AGPL-3.0-or-later
Package: bashtard
Architecture: all
Maintainer: Patrick Spek <p.spek@tyil.nl>
Priority: optional
Section: admin
Description: Configuration Management System in Bash
 Bashtard is a configuration management system built on the idea of simplicity
 for the user. It lets you write reasonably simple Bash scripts to configure
 your systems, while providing just enough abstractions to make it easy to
 work with various base systems.
 It is similar in purpose as other configuration management tools, such as
 Ansible and Puppet, however Bashtard tries to keep dependencies to a minimum
 while still providing some abstractions to make the process easier. This
 allows Bashtard to run in more constrained environments, with the abstractions
 allowing it to manage a varied array of systems in a single network.
